=== debian/changelog ===
xnnpack (0.0~git20240821.87ee0b4-3) unstable; urgency=medium

  * Team upload.
  * Mark libxnnpack0 as "Multi-Arch: same"

 -- Dylan Aïssi <daissi@debian.org>  Tue, 21 Jan 2025 12:23:32 +0100

xnnpack (0.0~git20240821.87ee0b4-2) unstable; urgency=medium

  * Team upload.
  * d/rules: disable kleidiai to fix build on arm64 (see: #1081414)
  * d/rules: add exception in CFLAGS to fix build on arm{hf,64}

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 11 Sep 2024 21:45:39 +0800

xnnpack (0.0~git20240821.87ee0b4-1) unstable; urgency=medium

  [ Shengqi Chen ]
  * Team upload.
  * New upstream version 0.0~git20240821.87ee0b4
    Please use this snapshot for PyTorch/2.4.X releases.
  * d/patches: refresh patch and add DEP3 header
  * d/control: 
    + add python3 in B-D, limit architecture to supported platforms
    + bump std-ver to 4.7.0.1 (no changes required)
  * d/rules:
    + fix indentation
    + remove override_dh_dwz which is now unnecessary
    + fix wrong hardening flags
  * d/copyright: remove unused BSD-2-Clause paragraph

  [ Aron Xu ]
  * d/rules: disable tests for known failures

 -- Shengqi Chen <harry-chen@outlook.com>  Thu, 05 Sep 2024 00:26:23 +0800

xnnpack (0.0~git20240229.fcbf55a-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20240229.fcbf55a
    + Please pin to this snapshot for PyTorch/2.3.X release.
  * Refresh existing patches.
  * Add new cmake flags to avoid cmake failure.
  * Add version requirement to pthreadpool.
  * Bump version requirement on B-D cpuinfo.
  * Add a file in not-installed.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 11 Jul 2024 01:05:18 -0400
