## xnnpack 0.0~git20241108.4ea82e5

=== CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
   ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
     SET(XNNPACK_TARGET_PROCESSOR "arm64")
   ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64EC")
-    SET(XNNPACK_TARGET_PROCESSOR "arm64ec")
+    SET(XNNPACK_TARGET_PROCESSOR "arm64")
   ELSE()
     MESSAGE(FATAL_ERROR "Unsupported Visual Studio architecture \"${CMAKE_GENERATOR_PLATFORM}\"")
   ENDIF()
@@ -106,10 +106,25 @@
 OPTION(XNNPACK_ENABLE_ARM_BF16 "Build XNNPACK with ARM BF16 (BFLOAT16) micro-kernels" ON)
 OPTION(XNNPACK_ENABLE_ARM_DOTPROD "Build XNNPACK with ARM DotProd (integer dot product) micro-kernels" ON)
 OPTION(XNNPACK_ENABLE_ARM_I8MM "Build XNNPACK with ARM I8MM (8-bit integer matrix multiply accumulate) micro-kernels" ON)
-IF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
-  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
-    SET(XNNPACK_ENABLE_ARM_I8MM OFF)
-  ENDIF()
+OPTION(XNNPACK_ENABLE_ARM_SME "Build XNNPACK with ARM SME micro-kernels" ON)
+OPTION(XNNPACK_ENABLE_ARM_SME2 "Build XNNPACK with ARM SME2 micro-kernels" ON)
+IF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "arm(64)?")
+  SET(XNNPACK_ENABLE_ARM_FP16_SCALAR OFF)
+  SET(XNNPACK_ENABLE_ARM_FP16_VECTOR OFF)
+  SET(XNNPACK_ENABLE_ARM_BF16 OFF)
+  SET(XNNPACK_ENABLE_ARM_DOTPROD OFF)
+ENDIF()
+IF(NOT XNNPACK_TARGET_PROCESSOR STREQUAL "arm64")
+  SET(XNNPACK_ENABLE_ARM_I8MM OFF)
+  SET(XNNPACK_ENABLE_ARM_SME OFF)
+  SET(XNNPACK_ENABLE_ARM_SME2 OFF)
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang" AND CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
+  SET(XNNPACK_ENABLE_ARM_I8MM OFF)
+  SET(XNNPACK_ENABLE_ARM_SME OFF)
+  SET(XNNPACK_ENABLE_ARM_SME2 OFF)
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang" AND CMAKE_C_COMPILER_VERSION VERSION_LESS "18")
+  SET(XNNPACK_ENABLE_ARM_SME OFF)
+  SET(XNNPACK_ENABLE_ARM_SME2 OFF)
 ENDIF()
 OPTION(XNNPACK_ENABLE_RISCV_VECTOR "Build XNNPACK with RISC-V Vector micro-kernels" ON)
 OPTION(XNNPACK_ENABLE_VSX "Build XNNPACK with VSX Vector micro-kernels for Power" ON)
@@ -123,6 +138,19 @@
     SET(XNNPACK_ENABLE_AVXVNNI OFF)
   ENDIF()
 ENDIF()
+OPTION(XNNPACK_ENABLE_AVXVNNIINT8 "Build XNNPACK with AVX-VNNI-INT8 micro-kernels" ON)
+IF(CMAKE_SYSTEM_NAME MATCHES "^(Android|Darwin|iOS)$")
+  SET(XNNPACK_ENABLE_AVXVNNIINT8 OFF)
+ENDIF()
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "17")
+    SET(XNNPACK_ENABLE_AVXVNNIINT8 OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "17")
+    SET(XNNPACK_ENABLE_AVXVNNIINT8 OFF)
+  ENDIF()
+ENDIF()
 OPTION(XNNPACK_ENABLE_AVX256SKX "Build XNNPACK with AVX256SKX micro-kernels" ON)
 IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
   IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
@@ -151,6 +179,46 @@
 ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
   IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
     SET(XNNPACK_ENABLE_AVX256VNNIGFNI OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512F "Build XNNPACK with AVX512F micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512F OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512F OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512SKX "Build XNNPACK with AVX512SKX micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512SKX OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512SKX OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512VBMI "Build XNNPACK with AVX512VBMI micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512VBMI OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512VBMI OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512VNNI "Build XNNPACK with AVX512VNNI micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512VNNI OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512VNNI OFF)
   ENDIF()
 ENDIF()
 OPTION(XNNPACK_ENABLE_AVX512VNNIGFNI "Build XNNPACK with AVX512VNNIGFNI micro-kernels" ON)
@@ -206,50 +274,3 @@
 ENDIF()
 
 ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_VECTOR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_VECTOR}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_SCALAR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_SCALAR}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_BF16=$<BOOL:${XNNPACK_ENABLE_ARM_BF16}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_DOTPROD=$<BOOL:${XNNPACK_ENABLE_ARM_DOTPROD}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_I8MM=$<BOOL:${XNNPACK_ENABLE_ARM_I8MM}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_RISCV_VECTOR=$<BOOL:${XNNPACK_ENABLE_RISCV_VECTOR}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVXVNNI=$<BOOL:${XNNPACK_ENABLE_AVXVNNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256SKX=$<BOOL:${XNNPACK_ENABLE_AVX256SKX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256VNNI=$<BOOL:${XNNPACK_ENABLE_AVX256VNNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256VNNIGFNI=$<BOOL:${XNNPACK_ENABLE_AVX256VNNIGFNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512VNNIGFNI=$<BOOL:${XNNPACK_ENABLE_AVX512VNNIGFNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512AMX=$<BOOL:${XNNPACK_ENABLE_AVX512AMX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512FP16=$<BOOL:${XNNPACK_ENABLE_AVX512FP16}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_VSX=$<BOOL:${XNNPACK_ENABLE_VSX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ASSEMBLY=$<BOOL:${XNNPACK_ENABLE_ASSEMBLY}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_MEMOPT=$<BOOL:${XNNPACK_ENABLE_MEMOPT}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_SPARSE=$<BOOL:${XNNPACK_ENABLE_SPARSE}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_GEMM_M_SPECIALIZATION=$<BOOL:${XNNPACK_ENABLE_GEMM_M_SPECIALIZATION}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_DWCONV_MULTIPASS=$<BOOL:${XNNPACK_ENABLE_DWCONV_MULTIPASS}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_HVX=$<BOOL:${XNNPACK_ENABLE_HVX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_KLEIDIAI=$<BOOL:${XNNPACK_ENABLE_KLEIDIAI}>")
-
-IF(XNNPACK_TARGET_PROCESSOR MATCHES "Hexagon")
-  ADD_COMPILE_DEFINITIONS("XNN_ENABLE_CPUINFO=0")
-ELSE()
-  ADD_COMPILE_DEFINITIONS("XNN_ENABLE_CPUINFO=1")
-ENDIF()
-
-IF(USE_GNU_SOURCE)
-  ADD_COMPILE_DEFINITIONS(_GNU_SOURCE)
-ENDIF()
-
-IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
-  # Disable "unary minus operator applied to unsigned type, result still unsigned" warning
-  ADD_COMPILE_OPTIONS("/wd4146")
-  # Test files have many sections, increase the limit. See
-  # https://learn.microsoft.com/en-us/cpp/build/reference/bigobj-increase-number-of-sections-in-dot-obj-file.
-  ADD_COMPILE_OPTIONS("/bigobj")
-ENDIF()
-
-IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-  # Disable "note: parameter passing for argument of type ... changed/will change in ..."
-  ADD_COMPILE_OPTIONS("-Wno-psabi")
-ENDIF()
-
-# ---[ Build flags
-IF(NOT CMAKE_SYSTEM_NAME)
-  MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")
