=== debian/changelog ===
xnnpack (0.0~git20241108.4ea82e5-2) unstable; urgency=medium

  * Gbp-Dch: bump std-ver to 4.7.2 (no changes required).
  * d/{control,rules}: build with kleidiai on arm64.
  * d/control: mark libxnnpack-dev as Multi-Arch: same.

 -- Shengqi Chen <harry@debian.org>  Sun, 13 Apr 2025 15:11:05 +0800

xnnpack (0.0~git20241108.4ea82e5-1) unstable; urgency=medium

  * d/control: add myself in uploaders
  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Mon, 17 Feb 2025 23:45:51 +0800

xnnpack (0.0~git20241108.4ea82e5-1~exp2) experimental; urgency=medium

  * Team upload.
  * d/patches: backport FTBFS fix with GCC 13 on arm64 from upstream

 -- Shengqi Chen <harry@debian.org>  Sun, 26 Jan 2025 00:01:33 +0800

xnnpack (0.0~git20241108.4ea82e5-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20241108.4ea82e5
    Please use this snapshot for PyTorch/2.6+ releases.
  * Install libmicrokernels-prod.a in libxnnpack-dev
  * d/control: use correct std-ver 4.7.0
  * Bump SOVERSION to libxnnpack0.20241108 to reflect API changes
  * d/copyright: add new author names according to upstream

 -- Shengqi Chen <harry@debian.org>  Fri, 24 Jan 2025 13:57:27 +0800
