=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: math
 Homepage: https://github.com/google/XNNPACK
 Priority: optional
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/xnnpack.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/xnnpack
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
-Uploaders: Mo Zhou <lumin@debian.org>
+Uploaders: Mo Zhou <lumin@debian.org>, Shengqi Chen <harry@debian.org>
 Rules-Requires-Root: no
 Build-Depends: cmake,
                debhelper-compat (= 13),
@@ -14,6 +14,7 @@
                libcpuinfo-dev (>= 0.0~git20231104.d6860c4~),
                libfp16-dev,
                libfxdiv-dev,
+               libkleidiai-dev [arm64],
                libpsimd-dev,
                libpthreadpool-dev (>= 0.0~git20240616.560c60d~),
                ninja-build,
@@ -22,7 +23,8 @@
 Package: libxnnpack-dev
 Section: libdevel
 Architecture: amd64 i386 x32 armhf arm64 riscv64
-Depends: libxnnpack0 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: libxnnpack0.20241108 (= ${binary:Version}), ${misc:Depends}
 Description: High-efficiency floating-point neural network inference operators (dev)
  XNNPACK is a highly optimized library of floating-point neural network
  inference operators for ARM, WebAssembly, and x86 platforms. XNNPACK is not
@@ -33,7 +35,7 @@
  .
  This package contains the development files.
 
-Package: libxnnpack0
+Package: libxnnpack0.20241108
 Section: libs
 Architecture: amd64 i386 x32 armhf arm64 riscv64
 Multi-Arch: same
@@ -46,4 +48,4 @@
  machine learning frameworks, such as TensorFlow Lite, TensorFlow.js, PyTorch,
  and MediaPipe.
  .
- This package contains the shared object.
+ This package contains the shared library.
